Kiwi.Plugins.Collectable = {
	name:'Collectable',
	version:'0.5.0',
	minimumKiwiVersion:'1.1.1',
	kiwifrootPlugins:[]
};

Kiwi.PluginManager.register(Kiwi.Plugins.Collectable);

Kiwi.Plugins.Collectable.Component = function(gameObject){
	Kiwi.Component.call(this, gameObject, 'Collectable');

	this.state = this.owner.state;
	this.box = this.owner.components.getComponent("Box");

};

Kiwi.extend(Kiwi.Plugins.Collectable.Component, Kiwi.Component);

Kiwi.Plugins.Collectable.Component.prototype.boot = function() {
	this.arcadephysics = this.owner.components.getComponent( "ArcadePhysics" );
	this.owner.visible = false;

	if( !this.arcadephysics ) {
		Kiwi.Log.error("ArcadePhysics component not found on the state. ArcadePhysics blocks will not work.", "#arcadephysics");
	} else {
		this.arcadesystem = this.arcadephysics.system;
	}

	//Attach the information to the boot method.
	//This is to make sure all the components are loaded/attached before executing any code.
	this.onCreate();
};

Kiwi.Plugins.Collectable.Component.add = function(state, gameObject, params){
	var component = new Kiwi.Plugins.Collectable.Component(gameObject);
	gameObject.components.add(component);

};

Kiwi.Plugins.Collectable.Component.prototype.setCollision = function(collisionSide, active) {
	if( active ) {
		this.arcadephysics.allowCollisions = this.arcadephysics.allowCollisions | collisionSide;
	} else if( !active ) {
		this.arcadephysics.allowCollisions = this.arcadephysics.allowCollisions ^ collisionSide;
	}
	return;
}

Kiwi.Plugins.Collectable.Component.prototype.onCreate = function() {
	this.owner.addTag('collectable');
	this.arcadephysics.enabled = false;
};

Kiwi.Plugins.Collectable.Component.prototype.destroy = function(){
	this.owner.exists = false;
	Kiwi.Component.prototype.destroy.call( this );
	this.state = null;
	this.box = null;
};

Kiwi.Plugins.Collectable.kiwifrootPlugins.push({
	type: Kiwifroot.Plugins.COMPONENT,
	name: 'Collectable',
	namespace: Kiwi.Plugins.Collectable.Component
});
