Kiwi.Plugins.Gameoverscreen = {
	name:'Gameoverscreen',
	version:'0.5.0',
	minimumKiwiVersion:'1.1.1',
	kiwifrootPlugins:[]
};

Kiwi.PluginManager.register(Kiwi.Plugins.Gameoverscreen);

Kiwi.Plugins.Gameoverscreen.Component = function(gameObject){
	Kiwi.Component.call(this, gameObject, 'Gameoverscreen');

	this.state = this.owner.state;
	this.box = this.owner.components.getComponent("Box");
};

Kiwi.extend(Kiwi.Plugins.Gameoverscreen.Component, Kiwi.Component);

Kiwi.Plugins.Gameoverscreen.Component.prototype.boot = function() {

	//Attach the information to the boot method.
	//This is to make sure all the components are loaded/attached before executing any code.
	this.onCreate();
};

Kiwi.Plugins.Gameoverscreen.Component.add = function(state, gameObject, params){
	var component = new Kiwi.Plugins.Gameoverscreen.Component(gameObject);
	gameObject.components.add(component);


};

Kiwi.Plugins.Gameoverscreen.Component.prototype.onCreate = function() {
	this.owner.visible = false;
	this.owner.addTag('Gameoverscreen');
	this._deflectText = this.state.objects.create( {
		"type": 'text', 
		"x": this.game.stage.width / 2,
		"y": 540,
		"text": '',
		"textAlign": "center",
		"fontFamily": '"nokia"',
		"color": "#ffffff",
		"fontSize": 50
    }, this.state, false );
    this._deflectText.visible = false;

    this.playButton = this.state.objects.create( {
		"type": 'static-image', 
		"x": 25,
		"y": 720,
		"imageId": 14,
		 "components": {
			"animation": {
			  "idle": {
			    "cells": [
			     	0
			    ],
			    "loop": false,
			    "play": true,
			    "speed": 0.025
			  }
			}
		}
    }, this.state, false );
    this.playButton.visible = false;

    this.submitScore = this.state.objects.create( {
		"type": 'static-image', 
		"x": 25,
		"y": 820,
		"imageId": 15,
		 "components": {
			"animation": {
			  "idle": {
			    "cells": [
			     	0
			    ],
			    "loop": false,
			    "play": true,
			    "speed": 0.025
			  }
			}
		}
    }, this.state, false );
    this.submitScore.visible = false;
};


Kiwi.Plugins.Gameoverscreen.Component.prototype.onStageClick = function(x, y, timeDown, timeUp, duration, pointer) {

	var point = this.game.cameras.defaultCamera.transformPoint( pointer.point );

	if (this.submitScore.box.worldHitbox.containsPoint( point )) {

		this.state.components.getComponent("KiwifrootLeaderboardPortrait").showLeaderboard({
			score: this._deflectText.text,
			playAgainCallback: this._playAgain,
			context: this,
			font: '"nokia"',
			fontColor: "#ffffff",
			fontSize: 28
		});
	}

	if (this.playButton.box.worldHitbox.containsPoint( point )) {
		this._playAgain();
	}
};

Kiwi.Plugins.Gameoverscreen.Component.prototype._playAgain = function() {
	this.game.ads.playFullscreen();
	this.game.info.switchLevelByNumber((this.game.info.currentLevelNumber));
};

Kiwi.Plugins.Gameoverscreen.Component.prototype.update = function() {
	Kiwi.Component.prototype.update.call( this );
	if( this.now_visible ) {
		this._deflectText.alpha += 0.025;
		this.submitScore.alpha += 0.025;
		this.playButton.alpha += 0.025;
		this.owner.alpha += 0.025;
	}
};

Kiwi.Plugins.Gameoverscreen.Component.prototype.show = function( score ) {
	this._deflectText.visible = true;
	this.submitScore.visible = true;
	this.playButton.visible = true;
	this.owner.visible = true;

	this.now_visible = true;
	this.owner.alpha = 0;
	this._deflectText.alpha = 0;
	this.submitScore.alpha = 0;
	this.playButton.alpha = 0;

	this.owner.x = 0;
	this.owner.y = 0;
	this._deflectText.text = Math.round(score); 
	this.owner.parent.addChild( this.owner );
	this.owner.parent.addChild( this.submitScore );
	this.owner.parent.addChild( this.playButton );
	this.owner.parent.addChild( this._deflectText );

	this.game.input.onUp.add(this.onStageClick, this, 25);
}

Kiwi.Plugins.Gameoverscreen.Component.prototype.destroy = function(){
	this.game.input.onUp.remove(this.onStageClick, this);
	Kiwi.Component.prototype.destroy.call( this );
	this.state = null;
	this.box = null;
};

Kiwi.Plugins.Gameoverscreen.kiwifrootPlugins.push({
	type: Kiwifroot.Plugins.COMPONENT,
	name: 'Gameoverscreen',
	namespace: Kiwi.Plugins.Gameoverscreen.Component
});
