Kiwi.Plugins.Playagain = {
	name:'Playagain',
	version:'0.5.0',
	minimumKiwiVersion:'1.1.1',
	kiwifrootPlugins:[]
};

Kiwi.PluginManager.register(Kiwi.Plugins.Playagain);

Kiwi.Plugins.Playagain.Component = function(gameObject){
	Kiwi.Component.call(this, gameObject, 'Playagain');

	this.state = this.owner.state;
	this.box = this.owner.components.getComponent("Box");

	this.game.input.onDown.add(this.onInstanceInputONDOWN, this, 50);
};

Kiwi.extend(Kiwi.Plugins.Playagain.Component, Kiwi.Component);

Kiwi.Plugins.Playagain.Component.prototype.boot = function() {


};

Kiwi.Plugins.Playagain.Component.add = function(state, gameObject, params){
	var component = new Kiwi.Plugins.Playagain.Component(gameObject);
	gameObject.components.add(component);


};

Kiwi.Plugins.Playagain.Component.prototype.onInstanceInputONDOWN = function(x, y, timeDown, timeUp, duration, pointer) {
	var point = this.game.cameras.defaultCamera.transformPoint( pointer.point );

	if (this.owner.box.worldHitbox.containsPoint( point )) {
	}

	if( y > this.game.stage.height / 2 ) {
		this.state.components.getComponent('KiwifrootLeaderboardPortrait').showLeaderboard( { 
			score: this.score,
			playAgainCallback: this.playAgain,
			context: this
		} );
	}
};

Kiwi.Plugins.Playagain.Component.prototype.playAgain = function() {
	this.game.info.switchLevelByNumber(0);
	this.game.ads.loadBanner( true );
	this.game.ads.bannerTop = false;
	this.game.ads.playFullscreen();
}

Kiwi.Plugins.Playagain.Component.prototype.destroy = function(){
	this.game.input.onDown.remove(this.onInstanceInputONDOWN, this);

	Kiwi.Component.prototype.destroy.call( this );
	this.state = null;
	this.box = null;
};

Kiwi.Plugins.Playagain.kiwifrootPlugins.push({
	type: Kiwifroot.Plugins.COMPONENT,
	name: 'Playagain',
	namespace: Kiwi.Plugins.Playagain.Component
});
