Kiwi.Plugins.Player = {
	name:'Player',
	version:'0.5.0',
	minimumKiwiVersion:'1.1.1',
	kiwifrootPlugins:[]
};

Kiwi.PluginManager.register(Kiwi.Plugins.Player);

Kiwi.Plugins.Player.Component = function(gameObject){
	Kiwi.Component.call(this, gameObject, 'Player');

	this.state = this.owner.state;
	this.box = this.owner.components.getComponent("Box");

	this.game.input.onDown.add(this.onStageTouch2, this, 25);
	this.game.input.onUp.add(this.onStageTouch32, this, 25);
	this.owner.properties.onUpdate( this.onMessageRecieved, this, "_messaging_");
	this.state.robots.onUpdate.add(this.onUpdate, this);
	this.game.input.keyboard.onKeyDownOnce.add(this.onKeyPressedONKEYDOWNONCE, this);
	this.game.input.keyboard.onKeyUp.add(this.onKeyPressedONKEYUP, this);
};

Kiwi.extend(Kiwi.Plugins.Player.Component, Kiwi.Component);

Kiwi.Plugins.Player.Component.prototype.boot = function() {
	this.camera = this.state.components.getComponent( "Camera" );

	if( !this.camera ) {
		Kiwi.Log.error("Camera component not found on the state. Camera blocks will not work.", "#camera");
	}

	this.arcadephysics = this.owner.components.getComponent( "ArcadePhysics" );

	if( !this.arcadephysics ) {
		Kiwi.Log.error("ArcadePhysics component not found on the state. ArcadePhysics blocks will not work.", "#arcadephysics");
	} else {
		this.arcadesystem = this.arcadephysics.system;
	}

	this.animation = this.owner.components.getComponent( "Animation" );

	if( !this.animation ) {
		Kiwi.Log.error("Animation component not found on object. Animation blocks will not work.", "#animation");
	}

	//Attach the information to the boot method.
	//This is to make sure all the components are loaded/attached before executing any code.
	this.onCreate();
};

Kiwi.Plugins.Player.Component.add = function(state, gameObject, params){
	var component = new Kiwi.Plugins.Player.Component(gameObject);
	gameObject.components.add(component);

	component.pointer = params["pointer"];
	component.start = params["start"];
	component.end = params["end"];
	component.time = params["time"];
	component.right = params["right"];
	component.drag = params["drag"];
	component.speed = params["speed"];
	component.angle = params["angle"];
	component.start_game = params["start-game"];
	component.left = params["left"];
	component.space = params["space"];
};

Kiwi.Plugins.Player.Component.prototype.executeMessageRecieved = function() {
	this.start_game = true;
	//this.AnimateTo( this.game.stage.height, ( this.game.stage.height / 2 ), 2);

	var tween = this.game.tweens.create( this.owner );
	tween.to( {
		y: this.game.stage.height / 2
	}, 2000, Kiwi.Animations.Tweens.Easing.Sinusoidal.Out, true );

	this.animation.play("driving");
	var inst = this.state.objects.create( {
		"type": 'static-image', 
		"x": 0,
		"y": 0,
		"imageId": 17,
		 "components": {
			"animation": {
			  "idle": {
			    "cells": [
			     	0
			    ],
			    "loop": false,
			    "play": true,
			    "speed": 0.025
			  }
			}
		}
    }, this.state, false );


    var i = setInterval( function(){
    	inst.alpha = inst.alpha - .02;
    	if ( inst.alpha < 0.01){
    		clearInterval( i );
    	}
    }, 40);
};

Kiwi.Plugins.Player.Component.prototype.onUpdate = function() {
	if (this.start_game) {
		if (this.left) {
			if (this.space) {
				this.doubleLeft();
			} else {
				this.left2();
			}
		}
		if (this.right) {
			if (this.space) {
				this.doubleRight();
			} else {
				this.right2();
			}
		}
	}
};

Kiwi.Plugins.Player.Component.prototype.executeMessageRecieved2 = function() {
	this.die();
};


Kiwi.Plugins.Player.Component.prototype.onKeyInput = function() {
	this.left = true;
};

Kiwi.Plugins.Player.Component.prototype.executeMessageRecieved3 = function() {
};

Kiwi.Plugins.Player.Component.prototype.onCreate = function() {
	this.owner.addTag('player');
	this.setMiddleAnchor();
	this.addDrag(5);
	this.owner.y = ( this.game.stage.height ) + 20;
};

Kiwi.Plugins.Player.Component.prototype.onKeyInput2 = function() {
	this.left = false;
	this.setMiddleAnchor();
};

Kiwi.Plugins.Player.Component.prototype.executeMessageRecieved4 = function() {
};

Kiwi.Plugins.Player.Component.prototype.executeMessageRecieved5 = function() {
	this.die();
};

Kiwi.Plugins.Player.Component.prototype.onKeyInput3 = function() {
	this.left = false;
	this.right2();
};

Kiwi.Plugins.Player.Component.prototype.onSingleTick = function() {
	if (this.start < this.end) {
		this.owner.y = (this.start);
		this.AnimateTo(this.start + 3, this.end, this.time);
	} else if (this.start > this.end) {
		this.owner.y = (this.start);
		this.AnimateTo(this.start - 3, this.end, this.time);
	} 
};

Kiwi.Plugins.Player.Component.prototype.onKeyInput4 = function() {
	this.right = false;
	this.setMiddleAnchor();
};

Kiwi.Plugins.Player.Component.prototype.onSingleTick2 = function() {
	this.owner.scaleX = 1;
	this.owner.scaleY = 1;
};

Kiwi.Plugins.Player.Component.prototype.onStageTouch2 = function( x, y, td, tu, dur, pointer ) {
	this.pointer = pointer;
	if (this.start_game) {
		if (this.pointer.x >= this.game.stage.width / 2) {
			this.right = true;
		} else {
			this.left = true;
		}
	}

};

Kiwi.Plugins.Player.Component.prototype.onStageTouch32 = function( x, y, td, tu, dur, pointer ) {
	this.pointer = pointer;
	if (this.start_game) {
		if (this.pointer.startPoint.x >= this.game.stage.width / 2) {
			this.right = false;
		} else {
			this.left = false;
		}
	}

};

Kiwi.Plugins.Player.Component.prototype.onMessageRecieved = function( name, message ) {
	switch( message ) {
		case 'START-GAME': this.executeMessageRecieved(); break;
		case 'die': this.executeMessageRecieved2(); break;
		case 'explode': this.executeMessageRecieved3(); break;
		case 'powerup': this.executeMessageRecieved4(); break;
		case 'OFF-ROAD': this.executeMessageRecieved5(); break;
	}
};

Kiwi.Plugins.Player.Component.prototype.onKeyPressedONKEYDOWNONCE = function(keyCode) {
	switch (keyCode) {
		case 37: this.onKeyInput(); break;
		case 39: this.onKeyInput3(); break;
	}
};

Kiwi.Plugins.Player.Component.prototype.onKeyPressedONKEYUP = function(keyCode) {
	switch (keyCode) {
		case 37: this.onKeyInput2(); break;
		case 39: this.onKeyInput4(); break;
	}
};

Kiwi.Plugins.Player.Component.prototype.messageEachGameObject = function( group, message ) {
	group.forEach( this, function( child ) {
		child.properties.set( "_messaging_", message );
		if( child.childType() == Kiwi.Group ) {
			this.messageEachGameObject( child, message );
		}
	});
	return;
}

Kiwi.Plugins.Player.Component.prototype.die = function() {

	if( this.unitDead ) return;

	this.unitDead = true;
	this.animation.play( 'explode' );
	this.state.sounds.playSoundEffect( 4 );

	this.wreak = this.state.objects.create( {
		"type": "static-image",
		"x": this.owner.x,
		"y": this.owner.y,
		"imageId": 8,
		"visible": false
	}, this.state, false );
	this.wreak.x = this.owner.x + this.owner.width / 2 - this.wreak.width / 2;
	this.wreak.y = this.owner.y + this.owner.height / 2 - this.wreak.height / 2;
	this.wreak.rotation = this.owner.rotation;
	this.wreak.anchorPointX = this.wreak.width / 2;
	this.wreak.anchorPointY = this.wreak.height / 2;
	this.wreak.transform.scale = 0.75;

	var that = this;
	setTimeout( function() {
		that.owner.visible = false;
		that.wreak.visible = true;
	}, 50);

	this.explosion = this.state.objects.create( {
		"type": "static-image",
		"x": this.owner.x,
		"y": this.owner.y - 100,
		"imageId": 6,
		"scaleX": 0.5,
		"scaleY": 0.5,
		"components": {
			"animation": {
	          "idle": {
	            "cells": [
	             	0, 0, 1, 1, 2, 2, 3, 3, 4, 4, 5, 5, 5
	            ],
	            "loop": false,
	            "play": true,
	            "speed": 0.025
	          }
        	}
		}
	}, this.state, false );

	this.explosion.x = this.owner.x + this.owner.width / 2 - this.explosion.width / 2;
	this.explosion.y = this.owner.y + this.owner.height / 2 - this.explosion.height / 2 - 100;
	this.explosion.anchorPointX = this.explosion.width / 2;
	this.explosion.anchorPointY = this.explosion.height / 2;

	this.messageEachGameObject( this.state, 'STOP');

	var anim = this.explosion.components.getComponent("Animation");
	anim.currentAnimation.onComplete.add( function( inst ) {
		this.explosion.visible = false;

		setTimeout( function() {
			this.messageEachGameObject( this.state, 'GAME-OVER');
		}.bind( this ), 200);
	}, this);

}

Kiwi.Plugins.Player.Component.prototype.setMiddleAnchor = function() {
	this.owner.anchorPointX = this.owner.width / 2;
	this.owner.anchorPointY = this.owner.height / 2;
}

Kiwi.Plugins.Player.Component.prototype.AnimateTo = function(start, end, time) {
	this.start = start;
	this.end = end;
	this.time = time;
	if (this.start == 0) {
		this.start = 1;
	}
	this.onSingleTick_ = this.game.time.clock.setTimeout( function() {
			if( this.owner && this.owner.exists ) {
				this.onSingleTick();
			}
		}, this.time, this);
}

Kiwi.Plugins.Player.Component.prototype.left2 = function() {
	this.setRotation(false);
	this.moveLeft(20);
}

Kiwi.Plugins.Player.Component.prototype.right2 = function() {
	this.setRotation(true);
	this.moveRight(20);
}

Kiwi.Plugins.Player.Component.prototype.forward2 = function() {
	this.moveForward(10);
}

Kiwi.Plugins.Player.Component.prototype.jump = function() {
	this.owner.scaleX = 1.5;
	this.owner.scaleY = 1.5;
	this.onSingleTick2_ = this.game.time.clock.setTimeout( function() {
			if( this.owner && this.owner.exists ) {
				this.onSingleTick2();
			}
		}, 100, this);
}

Kiwi.Plugins.Player.Component.prototype.doubleRight = function() {
	this.moveRight(5);
	this.setAnchorPointsSides(true);
	this.deccelerate();
}

Kiwi.Plugins.Player.Component.prototype.deccelerate = function() {
	this.arcadephysics.velocity.y = (this.arcadephysics.velocity.y + 1);
}

Kiwi.Plugins.Player.Component.prototype.setRotation = function(right) {
	this.right = right;
	if (this.right) {
		this.owner.rotation = ((this.owner.rotation * Kiwi.Utils.GameMath.RAD_TO_DEG) + 2) * Kiwi.Utils.GameMath.DEG_TO_RAD;
	} else {
		this.owner.rotation = ((this.owner.rotation * Kiwi.Utils.GameMath.RAD_TO_DEG) - 2) * Kiwi.Utils.GameMath.DEG_TO_RAD;
	}
}

Kiwi.Plugins.Player.Component.prototype.doubleLeft = function() {
	this.arcadephysics.velocity.x = (this.arcadephysics.velocity.x - 10);
	this.setAnchorPointsSides(false);
	this.deccelerate();
}

Kiwi.Plugins.Player.Component.prototype.addDrag = function(drag) {
	this.drag = drag;
	this.arcadephysics.drag.y = this.drag;
	this.arcadephysics.drag.x = this.drag;
}

Kiwi.Plugins.Player.Component.prototype.moveBack = function(speed) {
	this.speed = speed;
	this.lookAt(180);
	this.arcadephysics.velocity.y = (this.arcadephysics.velocity.y + this.speed);
}

Kiwi.Plugins.Player.Component.prototype.lookAt = function(angle) {
	this.angle = angle;
	this.AnimateTo((this.owner.rotation * Kiwi.Utils.GameMath.RAD_TO_DEG), this.angle, 2);
}

Kiwi.Plugins.Player.Component.prototype.setAnchorPointsSides = function(right) {
	this.right = right;
	if (this.right) {
		if (this.owner.anchorPointX != this.owner.width - 2) {
			this.owner.anchorPointX = this.owner.width - 2;
			this.owner.anchorPointY = 0;
			this.owner.x = this.owner.x - 2;
		}
	} else {
		if (this.owner.anchorPointX != 2) {
			this.owner.anchorPointX = 2;
			this.owner.anchorPointY = 0;
			this.owner.x = this.owner.x + 2;
		}
	}
}

Kiwi.Plugins.Player.Component.prototype.moveLeft = function(speed) {
	this.speed = speed;
	this.arcadephysics.velocity.x = (this.arcadephysics.velocity.x - this.speed);
}

Kiwi.Plugins.Player.Component.prototype.moveRight = function(speed) {
	this.speed = speed;
	this.arcadephysics.velocity.x = (this.arcadephysics.velocity.x + this.speed);
}

Kiwi.Plugins.Player.Component.prototype.moveForward = function(speed) {
	this.speed = speed;
	this.arcadephysics.velocity.y = (this.arcadephysics.velocity.y + -this.speed);
}

Kiwi.Plugins.Player.Component.prototype.update = function() {
	Kiwi.Component.prototype.update.call( this );
	this.renderDebug();
}

Kiwi.Plugins.Player.Component.prototype.renderDebug = function() {
	if( !this.game.debugMode ) {
		return;
	}

	this.game.stage.dctx.fillStyle = '#ffffff';
	this.game.stage.dctx.fillRect( this.x + this.width / 2 - 3, this.y + this.height / 2 - 3, 6, 6 );

}

Kiwi.Plugins.Player.Component.prototype.destroy = function(){
	this.game.input.onDown.remove(this.onStageTouch2, this);
	this.game.input.onUp.remove(this.onStageTouch32, this);
	this.state.robots.onUpdate.remove(this.onUpdate, this);
	this.game.input.keyboard.onKeyDownOnce.remove(this.onKeyPressedONKEYDOWNONCE, this);
	this.game.input.keyboard.onKeyUp.remove(this.onKeyPressedONKEYUP, this);

	Kiwi.Component.prototype.destroy.call( this );
	this.state = null;
	this.box = null;
};

Kiwi.Plugins.Player.kiwifrootPlugins.push({
	type: Kiwifroot.Plugins.COMPONENT,
	name: 'Player',
	namespace: Kiwi.Plugins.Player.Component
});
