Kiwi.Plugins.stageClick = {
	name:'stageClick',
	version:'0.5.0',
	minimumKiwiVersion:'1.1.1',
	kiwifrootPlugins:[]
};

Kiwi.PluginManager.register(Kiwi.Plugins.stageClick);

Kiwi.Plugins.stageClick.Component = function(gameObject){
	Kiwi.Component.call(this, gameObject, 'stageClick');

	this.state = this.owner.state;
	this.box = this.owner.components.getComponent("Box");

	this.tapToStart = this.state.objects.create( {
		"type": "sprite",
		"imageId": 77,
		"y": 680,
		"x": 0
	}, this.state, false);

	this._interval = setInterval( function() {
		this.flash();
	}.bind( this ), 500);


	this.game.input.onDown.addOnce(function(){
		clearInterval( this._interval );
		this.owner.visible = false; 
		this.tapToStart.visible = false;
		this.game.ads.keepFullscreenAdReady = true;
		this.game.ads.loadFullscreen();
		//this.game.states.current.sounds.playBackgroundTrack( 10 );
		this.owner.exists = false;
		this.tapToStart.exists = false;
	}, this, 25);



};

Kiwi.extend(Kiwi.Plugins.stageClick.Component, Kiwi.Component);

Kiwi.Plugins.stageClick.Component.prototype.flash = function() {
	this.tapToStart.visible = !this.tapToStart.visible;
}

Kiwi.Plugins.stageClick.Component.prototype.boot = function() {

	//Attach the information to the boot method.
	//This is to make sure all the components are loaded/attached before executing any code.
	this.onCreate();
};

Kiwi.Plugins.stageClick.Component.add = function(state, gameObject, params){
	var component = new Kiwi.Plugins.stageClick.Component(gameObject);
	gameObject.components.add(component);


};

Kiwi.Plugins.stageClick.Component.prototype.onCreate = function() {
	//this.owner.visible = false;
	this.owner.addTag('stageClick');
};

Kiwi.Plugins.stageClick.Component.prototype.destroy = function(){

	Kiwi.Component.prototype.destroy.call( this );
	this.state = null;
	this.box = null;
};

Kiwi.Plugins.stageClick.kiwifrootPlugins.push({
	type: Kiwifroot.Plugins.COMPONENT,
	name: 'stageClick',
	namespace: Kiwi.Plugins.stageClick.Component
});
